import { IStreamFactory, TStreamChunk, TStreamError } from "./stream.js";
import { ISourceStream } from "./source.js";
import { ISinkStream } from "./sink.js";
interface IDuplexStream<T extends TStreamChunk, U extends TStreamChunk> extends ISourceStream<U>, ISinkStream<T> {
}
interface IDuplexStreamFactoryOptions<T extends TStreamChunk, U extends TStreamChunk> {
    fail: (args: {
        error: TStreamError;
    }) => void;
    next: (args: {
        chunks: U[];
    }) => void;
    end: () => void;
    drain: () => void;
}
interface IDuplexStreamFactory<T extends TStreamChunk, U extends TStreamChunk> extends IStreamFactory {
    open: (options: IDuplexStreamFactoryOptions<T, U>) => IDuplexStream<T, U>;
}
declare const duplex: <T extends TStreamChunk, U extends TStreamChunk>({ open }: IDuplexStreamFactory<T, U>) => IDuplexStreamFactory<T, U>;
declare const syncTransform: <T extends TStreamChunk, U extends TStreamChunk>({ start, transform, finish, thresholdMin, thresholdMax, maxPerTurn }: {
    start?: () => {
        error?: TStreamError;
        chunks?: U[];
    };
    transform: ({ chunks }: {
        chunks: T[];
    }) => {
        error?: TStreamError;
        chunks?: U[];
    };
    finish?: () => {
        error?: TStreamError;
        chunks?: U[];
    };
    thresholdMin?: number;
    thresholdMax?: number;
    maxPerTurn?: number;
}) => IDuplexStreamFactory<T, U>;
export type { IDuplexStream, IDuplexStreamFactoryOptions, IDuplexStreamFactory };
export { duplex, syncTransform };
